// This file is part of MinIO DirectPV
// Copyright (c) 2021, 2022 MinIO, Inc.
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Affero General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Affero General Public License for more details.
//
// You should have received a copy of the GNU Affero General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.

// Code generated by client-gen. DO NOT EDIT.

package fake

import (
	"context"

	v1beta3 "github.com/minio/directpv/pkg/apis/direct.csi.min.io/v1beta3"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	labels "k8s.io/apimachinery/pkg/labels"
	schema "k8s.io/apimachinery/pkg/runtime/schema"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	testing "k8s.io/client-go/testing"
)

// FakeDirectCSIDrives implements DirectCSIDriveInterface
type FakeDirectCSIDrives struct {
	Fake *FakeDirectV1beta3
}

var directcsidrivesResource = schema.GroupVersionResource{Group: "direct.csi.min.io", Version: "v1beta3", Resource: "directcsidrives"}

var directcsidrivesKind = schema.GroupVersionKind{Group: "direct.csi.min.io", Version: "v1beta3", Kind: "DirectCSIDrive"}

// Get takes name of the directCSIDrive, and returns the corresponding directCSIDrive object, and an error if there is any.
func (c *FakeDirectCSIDrives) Get(ctx context.Context, name string, options v1.GetOptions) (result *v1beta3.DirectCSIDrive, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootGetAction(directcsidrivesResource, name), &v1beta3.DirectCSIDrive{})
	if obj == nil {
		return nil, err
	}
	return obj.(*v1beta3.DirectCSIDrive), err
}

// List takes label and field selectors, and returns the list of DirectCSIDrives that match those selectors.
func (c *FakeDirectCSIDrives) List(ctx context.Context, opts v1.ListOptions) (result *v1beta3.DirectCSIDriveList, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootListAction(directcsidrivesResource, directcsidrivesKind, opts), &v1beta3.DirectCSIDriveList{})
	if obj == nil {
		return nil, err
	}

	label, _, _ := testing.ExtractFromListOptions(opts)
	if label == nil {
		label = labels.Everything()
	}
	list := &v1beta3.DirectCSIDriveList{ListMeta: obj.(*v1beta3.DirectCSIDriveList).ListMeta}
	for _, item := range obj.(*v1beta3.DirectCSIDriveList).Items {
		if label.Matches(labels.Set(item.Labels)) {
			list.Items = append(list.Items, item)
		}
	}
	return list, err
}

// Watch returns a watch.Interface that watches the requested directCSIDrives.
func (c *FakeDirectCSIDrives) Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error) {
	return c.Fake.
		InvokesWatch(testing.NewRootWatchAction(directcsidrivesResource, opts))
}

// Create takes the representation of a directCSIDrive and creates it.  Returns the server's representation of the directCSIDrive, and an error, if there is any.
func (c *FakeDirectCSIDrives) Create(ctx context.Context, directCSIDrive *v1beta3.DirectCSIDrive, opts v1.CreateOptions) (result *v1beta3.DirectCSIDrive, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootCreateAction(directcsidrivesResource, directCSIDrive), &v1beta3.DirectCSIDrive{})
	if obj == nil {
		return nil, err
	}
	return obj.(*v1beta3.DirectCSIDrive), err
}

// Update takes the representation of a directCSIDrive and updates it. Returns the server's representation of the directCSIDrive, and an error, if there is any.
func (c *FakeDirectCSIDrives) Update(ctx context.Context, directCSIDrive *v1beta3.DirectCSIDrive, opts v1.UpdateOptions) (result *v1beta3.DirectCSIDrive, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootUpdateAction(directcsidrivesResource, directCSIDrive), &v1beta3.DirectCSIDrive{})
	if obj == nil {
		return nil, err
	}
	return obj.(*v1beta3.DirectCSIDrive), err
}

// UpdateStatus was generated because the type contains a Status member.
// Add a +genclient:noStatus comment above the type to avoid generating UpdateStatus().
func (c *FakeDirectCSIDrives) UpdateStatus(ctx context.Context, directCSIDrive *v1beta3.DirectCSIDrive, opts v1.UpdateOptions) (*v1beta3.DirectCSIDrive, error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootUpdateSubresourceAction(directcsidrivesResource, "status", directCSIDrive), &v1beta3.DirectCSIDrive{})
	if obj == nil {
		return nil, err
	}
	return obj.(*v1beta3.DirectCSIDrive), err
}

// Delete takes name of the directCSIDrive and deletes it. Returns an error if one occurs.
func (c *FakeDirectCSIDrives) Delete(ctx context.Context, name string, opts v1.DeleteOptions) error {
	_, err := c.Fake.
		Invokes(testing.NewRootDeleteActionWithOptions(directcsidrivesResource, name, opts), &v1beta3.DirectCSIDrive{})
	return err
}

// DeleteCollection deletes a collection of objects.
func (c *FakeDirectCSIDrives) DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error {
	action := testing.NewRootDeleteCollectionAction(directcsidrivesResource, listOpts)

	_, err := c.Fake.Invokes(action, &v1beta3.DirectCSIDriveList{})
	return err
}

// Patch applies the patch and returns the patched directCSIDrive.
func (c *FakeDirectCSIDrives) Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *v1beta3.DirectCSIDrive, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootPatchSubresourceAction(directcsidrivesResource, name, pt, data, subresources...), &v1beta3.DirectCSIDrive{})
	if obj == nil {
		return nil, err
	}
	return obj.(*v1beta3.DirectCSIDrive), err
}
